<?php
// API doc : https://coincheck.com/ja/documents/exchange/api#public-trades
// API url : https://coincheck.com/api/trades

$coincheck_url  = "https://coincheck.com";
$trades_api = "/api/trades";
$url = $coincheck_url . $trades_api;

// arguments -> http query
$options = getopt("l:");
if (!check_arguments($options)) {
    usage();
    die(1);
}

$http_query = array(
    "pair"=>"btc_jpy"   
);
foreach ($options as $key => $value) {
    if     ($key == "l") { $http_query["limit"] = $value; }
}

if (count($http_query) > 0) {
    $url = $url . "?" . http_build_query($http_query);
}

// proxy settings
$proxy      = "";
$proxy_port = "";

$curl = curl_init();
if ($curl == FALSE) {
    fputs(STDERR, "[ERR] curl_init(): " . curl_error($curl) . PHP_EOL);
    die(1);
}

// curl set options
curl_setopt($curl, CURLOPT_URL, $url);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
// set proxy server settings
if (!empty($proxy) && !empty($proxy_port)) {
    curl_setopt($curl, CURLOPT_HTTPPROXYTUNNEL, 1);
    curl_setopt($curl, CURLOPT_PROXY, $proxy . ":" . $proxy_port);
    curl_setopt($curl, CURLOPT_PROXYPORT, $proxy_port);
}
// call trades api
$response = curl_exec($curl);
if ($response == FALSE) {
    fputs(STDERR, "[ERR] curl_exec(): " . curl_error($curl) . PHP_EOL);
    die(1);
}
curl_close($curl);

// json decode
$json_decode = json_decode($response, true);
if ($json_decode == NULL) {
    fputs(STDERR, "[ERR] json_decode(): " . json_last_error_msg() . PHP_EOL);
    die(1);
}
// output json_decode
print_r($json_decode);

exit(0);

//----------------------------------------------------------
// functions
//----------------------------------------------------------
function check_arguments($options) {
    if (array_key_exists("l", $options)) {
		if (!ctype_digit($options["l"])) {
			return FALSE;
		}
    }
    return TRUE;
}

function usage() {
    $usage =
    "Uasge: php trades.php [-l limit]" . PHP_EOL .
    "Options:" . PHP_EOL .
    "  -l : limit " . PHP_EOL .
    PHP_EOL;
    fputs(STDERR, $usage);
}
